package com.cirmuller.maidaddition.Utils.CraftingTasks;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import java.util.Collection;
import java.util.Iterator;
import java.util.LinkedList;
import java.util.List;
import javax.annotation.Nullable;
import net.minecraft.core.BlockPos;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.level.Level;
import net.minecraft.world.level.block.entity.BlockEntity;
import net.minecraftforge.common.capabilities.ForgeCapabilities;
import net.minecraftforge.common.util.LazyOptional;
import net.minecraftforge.items.IItemHandler;

public class ItemList extends LinkedList<ItemStack> {
  public boolean add(ItemStack itemStack) {
    for (ItemStack item : this) {
      if (item.m_41720_().equals(itemStack.m_41720_())) {
        item.m_41764_(item.m_41613_() + itemStack.m_41613_());
        return true;
      } 
    } 
    return super.add(itemStack.m_41777_());
  }
  
  public boolean addAll(Collection<? extends ItemStack> c) {
    if (c.isEmpty())
      return false; 
    for (ItemStack item : c)
      add(item); 
    return true;
  }
  
  @Nullable
  public ItemStack getItemInList(ItemStack item) {
    return getItemInList(item.m_41720_());
  }
  
  public boolean remove(Object o) {
    if (o instanceof ItemStack) {
      ItemStack targetItemStack = (ItemStack)o;
      for (ItemStack itemStack : this) {
        if (itemStack.m_41720_().equals(targetItemStack.m_41720_())) {
          if (itemStack.m_41613_() > targetItemStack.m_41613_()) {
            itemStack.m_41764_(itemStack.m_41613_() - targetItemStack.m_41613_());
            return true;
          } 
          return super.remove(itemStack);
        } 
      } 
      return false;
    } 
    return false;
  }
  
  @Nullable
  public ItemStack getItemInList(Item item) {
    for (ItemStack itemStack : this) {
      if (itemStack.m_41720_().equals(item))
        return itemStack; 
    } 
    return null;
  }
  
  public int getTotalCount() {
    int result = 0;
    for (ItemStack itemStack : this)
      result += itemStack.m_41613_(); 
    return result;
  }
  
  public static com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList getAbundantItemList(List<com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList> list) {
    assert !list.isEmpty();
    return list.stream().max((a, b) -> (a.getTotalCount() > b.getTotalCount()) ? 1 : ((a.getTotalCount() < b.getTotalCount()) ? -1 : 0))







      
      .get();
  }
  
  public String getString() {
    StringBuilder stringBuilder = new StringBuilder(256);
    int count = 0;
    for (ItemStack itemStack : this) {
      count++;
      stringBuilder.append(String.format("%-5s : %5d", new Object[] { itemStack.m_41611_().getString(), Integer.valueOf(itemStack.m_41613_()) }));
      if (count % 5 == 0) {
        stringBuilder.append("\n");
        continue;
      } 
      stringBuilder.append("     ");
    } 
    return stringBuilder.toString();
  }
  
  public com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList copy() {
    com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList result = new com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList();
    for (ItemStack item : this)
      result.add(item.m_41777_()); 
    return result;
  }
  
  public static com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList subtract(com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList A, com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList B) {
    com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList result = new com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList();
    for (ItemStack itemStack : A) {
      ItemStack itemInB = B.getItemInList(itemStack);
      if (itemInB == null) {
        result.add(itemStack.m_41777_());
        continue;
      } 
      if (itemStack.m_41613_() > itemInB.m_41613_())
        result.add(new ItemStack((ItemLike)itemStack.m_41720_(), itemStack.m_41613_() - itemInB.m_41613_())); 
    } 
    return result;
  }
  
  public static com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList getItemListFromChests(Level level, List<BlockPos> materialChests) {
    com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList result = new com.cirmuller.maidaddition.Utils.CraftingTasks.ItemList();
    for (Iterator<BlockPos> iterator = materialChests.iterator(); iterator.hasNext(); ) {
      BlockPos pos = iterator.next();
      BlockEntity chest = level.m_7702_(pos);
      if (chest == null)
        continue; 
      LazyOptional<IItemHandler> capability = chest.getCapability(ForgeCapabilities.ITEM_HANDLER);
      capability.ifPresent(cap -> {
            int sz = cap.getSlots();
            for (int i = 0; i < sz; i++)
              result.add(cap.getStackInSlot(i)); 
          });
    } 
    return result;
  }
}
